"use strict";
require("reflect-metadata");
function TestCase() {
    var testCaseArguments = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        testCaseArguments[_i - 0] = arguments[_i];
    }
    return function (target, propertyKey, descriptor) {
        var tests = Reflect.getMetadata("alsatian:tests", target);
        if (!tests) {
            tests = [{
                    key: propertyKey
                }];
            Reflect.defineMetadata("alsatian:tests", tests, target);
        }
        else if (tests.filter(function (test) { return test.key === propertyKey; }).length === 0) {
            tests.push({
                key: propertyKey
            });
            Reflect.defineMetadata("alsatian:tests", tests, target);
        }
        var testCases = Reflect.getMetadata("alsatian:testcases", target, propertyKey);
        if (!testCases) {
            testCases = [];
        }
        testCases.unshift({
            arguments: testCaseArguments
        });
        Reflect.defineMetadata("alsatian:testcases", testCases, target, propertyKey);
    };
}
exports.TestCase = TestCase;
//# sourceMappingURL=test-case-decorator.js.map