"use strict";
require("reflect-metadata");
function Test(description) {
    return function (target, propertyKey, descriptor) {
        var tests = Reflect.getMetadata("alsatian:tests", target);
        if (!tests) {
            tests = [{
                    key: propertyKey,
                    description: description
                }];
            Reflect.defineMetadata("alsatian:tests", tests, target);
        }
        else if (tests.filter(function (test) { return test.key === propertyKey; }).length === 0) {
            tests.push({
                key: propertyKey,
                description: description
            });
            Reflect.defineMetadata("alsatian:tests", tests, target);
        }
    };
}
exports.Test = Test;
//# sourceMappingURL=test-decorator.js.map