"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var test_case_decorator_1 = require("./test-case-decorator");
var test_decorator_1 = require("./test-decorator");
var async_test_decorator_1 = require("./async-test-decorator");
var expect_1 = require("./expect");
var focus_test_decorator_1 = require("./focus-test-decorator");
var focus_tests_decorator_1 = require("./focus-tests-decorator");
var match_error_1 = require("./errors/match-error");
var spy_on_1 = require("./spying/spy-on");
var ExampleTest = (function () {
    function ExampleTest() {
    }
    ExampleTest.prototype.checkIsTrue = function (value) {
        expect_1.Expect(value).toBe(true);
    };
    ExampleTest.prototype.checkIsNotTrue = function (value) {
        expect_1.Expect(value).not.toBe(true);
    };
    ExampleTest.prototype._ignoreMe = function () {
        console.log("you should not see me");
    };
    ExampleTest.prototype._iShouldBeRun = function () {
    };
    ExampleTest.prototype.errorTest = function () {
    };
    ExampleTest.prototype.asyncTest = function () {
        var promise = {};
        promise.then = function (callback) {
            promise.thenCallback = callback;
            return promise;
        };
        promise.catch = function (callback) {
            promise.catchCallback = callback;
            return promise;
        };
        setTimeout(function () {
            try {
                promise.thenCallback();
            }
            catch (error) {
                promise.catchCallback(error);
            }
        }, 1000);
        return promise;
    };
    ExampleTest.prototype.nicelyDescribedTest = function () {
    };
    ExampleTest.prototype.equalTest = function () {
        expect_1.Expect(!1).toEqual("1");
        expect_1.Expect(2).not.toEqual("1");
    };
    ExampleTest.prototype.matchTest = function () {
        expect_1.Expect("something").toMatch(/thing/);
        expect_1.Expect("something").not.toMatch(/that/);
    };
    ExampleTest.prototype.definedTest = function () {
        expect_1.Expect(null).toBeDefined();
        expect_1.Expect(undefined).not.toBeDefined();
    };
    ExampleTest.prototype.nullTest = function () {
        expect_1.Expect(null).toBeNull();
        expect_1.Expect(undefined).not.toBeNull();
    };
    ExampleTest.prototype.truthyTest = function () {
        expect_1.Expect(1).toBeTruthy();
        expect_1.Expect(0).not.toBeTruthy();
    };
    ExampleTest.prototype.containTest = function () {
        expect_1.Expect([1, 2, 3]).toContain(1);
        expect_1.Expect([1, 2, 3]).not.toContain(4);
    };
    ExampleTest.prototype.lessThanTest = function () {
        expect_1.Expect(3).toBeLessThan(4);
        expect_1.Expect(4).not.toBeLessThan(3);
    };
    ExampleTest.prototype.greaterThanTest = function () {
        expect_1.Expect(4).toBeGreaterThan(3);
        expect_1.Expect(3).not.toBeGreaterThan(4);
    };
    ExampleTest.prototype.throwTest = function () {
        expect_1.Expect(function () { throw new Error(); }).toThrow();
        expect_1.Expect(function () { }).not.toThrow();
    };
    ExampleTest.prototype.throwErrorTest = function () {
        expect_1.Expect(function () { throw new match_error_1.MatchError(1, 2, "Expected 1 to be 2."); }).toThrowError(match_error_1.MatchError, "Expected 1 to be 2.");
        expect_1.Expect(function () { throw new match_error_1.MatchError(1, 2, "Expected 1 to be 2."); }).not.toThrowError(match_error_1.MatchError, "Expected 1 to be 2.");
        expect_1.Expect(function () { throw new Error("Expected 1 to be 2."); }).not.toThrowError(match_error_1.MatchError, "Expected 1 to be 2.");
        expect_1.Expect(function () { throw new Error(); }).not.toThrowError(match_error_1.MatchError, "Expected 1 to be 2.");
    };
    ExampleTest.prototype.spyTest = function () {
        var test = new Example();
        spy_on_1.SpyOn(test, "test");
        spy_on_1.SpyOn(test, "testWithArgs");
        test.test();
        test.testWithArgs(1, "test");
        expect_1.Expect(test.test).toHaveBeenCalled();
        expect_1.Expect(test.testWithArgs).toHaveBeenCalledWith(1, "test");
    };
    __decorate([
        test_case_decorator_1.TestCase(true),
        test_case_decorator_1.TestCase(false),
        test_case_decorator_1.TestCase(1),
        test_case_decorator_1.TestCase(""),
        test_case_decorator_1.TestCase(undefined),
        test_case_decorator_1.TestCase(null), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Boolean]), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "checkIsTrue", null);
    __decorate([
        test_case_decorator_1.TestCase(true),
        test_case_decorator_1.TestCase(false),
        test_case_decorator_1.TestCase(1),
        test_case_decorator_1.TestCase(""), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Boolean]), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "checkIsNotTrue", null);
    __decorate([
        test_decorator_1.Test(),
        focus_test_decorator_1.FocusTest, 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "_iShouldBeRun", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "errorTest", null);
    __decorate([
        async_test_decorator_1.AsyncTest(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', Object)
    ], ExampleTest.prototype, "asyncTest", null);
    __decorate([
        test_decorator_1.Test("Nicely described test"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "nicelyDescribedTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "equalTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "matchTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "definedTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "nullTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "truthyTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "containTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "lessThanTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "greaterThanTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "throwTest", null);
    __decorate([
        test_decorator_1.Test(),
        focus_test_decorator_1.FocusTest, 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "throwErrorTest", null);
    __decorate([
        test_decorator_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ExampleTest.prototype, "spyTest", null);
    ExampleTest = __decorate([
        focus_tests_decorator_1.FocusTests, 
        __metadata('design:paramtypes', [])
    ], ExampleTest);
    return ExampleTest;
}());
exports.ExampleTest = ExampleTest;
var Example = (function () {
    function Example() {
        this.x = "i are a property";
    }
    Example.prototype.test = function () {
    };
    Example.prototype.testWithArgs = function (a, b) {
    };
    return Example;
}());
exports.Example = Example;
//# sourceMappingURL=example-test.js.map