"use strict";
var spy_call_1 = require("./spy-call");
var createSpy = function (originalFunction, context) {
    var stubbedSpy = function () {
        return stubbedSpy.returnValue;
    };
    var spy = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        spy.calls.push(new spy_call_1.SpyCall(args));
        return spy.handler.apply(context, args);
    };
    spy.calls = [];
    spy.return = function (value) {
        stubbedSpy.returnValue = value;
    };
    spy.andStub = function () {
        spy.handler = stubbedSpy;
    };
    spy.andCall = function (fakeFunction) {
        spy.handler = fakeFunction;
    };
    spy.andCallThrough = function () {
        spy.handler = originalFunction;
    };
    spy.handler = originalFunction;
    return spy;
};
function SpyOn(target, functionName) {
    var originalFunction = target[functionName];
    target[functionName] = createSpy(originalFunction, target);
}
exports.SpyOn = SpyOn;
//# sourceMappingURL=spy-on.js.map