"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var error_match_error_1 = require("../../../core/errors/error-match-error");
var alsatian_core_1 = require("../../../core/alsatian-core");
var ErrorMatchErrorTests = (function () {
    function ErrorMatchErrorTests() {
    }
    ErrorMatchErrorTests.prototype.noActualErrorShouldGiveCorrectMessage = function () {
        var error = new error_match_error_1.ErrorMatchError(null, true);
        alsatian_core_1.Expect(error.message).toBe("Expected an error to be thrown but no errors were thown.");
    };
    ErrorMatchErrorTests.prototype.actualErrorThrownWhenNoneExpectedShouldGiveCorrectMessage = function () {
        var error = new error_match_error_1.ErrorMatchError(new Error(), false);
        alsatian_core_1.Expect(error.message).toBe("Expected an error not to be thrown but an error was thown.");
    };
    ErrorMatchErrorTests.prototype.actualErrorIsNotCorrectTypeGivesCorrectMessage = function (ActualErrorType, ExpectedErrorType) {
        var error = new error_match_error_1.ErrorMatchError(new ActualErrorType(), true, ExpectedErrorType);
        alsatian_core_1.Expect(error.message).toBe("Expected an error of type " + ExpectedErrorType["name"] + " to have been thrown, but " + ActualErrorType["name"] + "was thrown instead.");
    };
    ErrorMatchErrorTests.prototype.actualErrorIsCorrectTypeButShouldntBeGivesCorrectMessage = function (ActualErrorType, ExpectedErrorType) {
        var error = new error_match_error_1.ErrorMatchError(new ActualErrorType(), true, ExpectedErrorType);
        alsatian_core_1.Expect(error.message).toBe("Expected an error of type " + ExpectedErrorType["name"] + " to have been thrown, but it shoudln't have been.");
    };
    __decorate([
        alsatian_core_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ErrorMatchErrorTests.prototype, "noActualErrorShouldGiveCorrectMessage", null);
    __decorate([
        alsatian_core_1.Test(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], ErrorMatchErrorTests.prototype, "actualErrorThrownWhenNoneExpectedShouldGiveCorrectMessage", null);
    __decorate([
        alsatian_core_1.TestCase(Error, EvalError),
        alsatian_core_1.TestCase(Error, ReferenceError),
        alsatian_core_1.TestCase(Error, SyntaxError),
        alsatian_core_1.TestCase(Error, TypeError),
        alsatian_core_1.TestCase(Error, URIError),
        alsatian_core_1.TestCase(ReferenceError, Error),
        alsatian_core_1.TestCase(ReferenceError, EvalError),
        alsatian_core_1.TestCase(ReferenceError, SyntaxError),
        alsatian_core_1.TestCase(ReferenceError, TypeError),
        alsatian_core_1.TestCase(ReferenceError, URIError),
        alsatian_core_1.TestCase(SyntaxError, Error),
        alsatian_core_1.TestCase(SyntaxError, EvalError),
        alsatian_core_1.TestCase(SyntaxError, ReferenceError),
        alsatian_core_1.TestCase(SyntaxError, TypeError),
        alsatian_core_1.TestCase(SyntaxError, URIError),
        alsatian_core_1.TestCase(TypeError, Error),
        alsatian_core_1.TestCase(TypeError, EvalError),
        alsatian_core_1.TestCase(TypeError, ReferenceError),
        alsatian_core_1.TestCase(TypeError, TypeError),
        alsatian_core_1.TestCase(TypeError, URIError),
        alsatian_core_1.TestCase(URIError, Error),
        alsatian_core_1.TestCase(URIError, EvalError),
        alsatian_core_1.TestCase(URIError, ReferenceError),
        alsatian_core_1.TestCase(URIError, TypeError),
        alsatian_core_1.TestCase(URIError, SyntaxError), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Function, Function]), 
        __metadata('design:returntype', void 0)
    ], ErrorMatchErrorTests.prototype, "actualErrorIsNotCorrectTypeGivesCorrectMessage", null);
    __decorate([
        alsatian_core_1.TestCase(Error, EvalError),
        alsatian_core_1.TestCase(Error, ReferenceError),
        alsatian_core_1.TestCase(Error, SyntaxError),
        alsatian_core_1.TestCase(Error, TypeError),
        alsatian_core_1.TestCase(Error, URIError),
        alsatian_core_1.TestCase(ReferenceError, Error),
        alsatian_core_1.TestCase(ReferenceError, EvalError),
        alsatian_core_1.TestCase(ReferenceError, SyntaxError),
        alsatian_core_1.TestCase(ReferenceError, TypeError),
        alsatian_core_1.TestCase(ReferenceError, URIError),
        alsatian_core_1.TestCase(SyntaxError, Error),
        alsatian_core_1.TestCase(SyntaxError, EvalError),
        alsatian_core_1.TestCase(SyntaxError, ReferenceError),
        alsatian_core_1.TestCase(SyntaxError, TypeError),
        alsatian_core_1.TestCase(SyntaxError, URIError),
        alsatian_core_1.TestCase(TypeError, Error),
        alsatian_core_1.TestCase(TypeError, EvalError),
        alsatian_core_1.TestCase(TypeError, ReferenceError),
        alsatian_core_1.TestCase(TypeError, TypeError),
        alsatian_core_1.TestCase(TypeError, URIError),
        alsatian_core_1.TestCase(URIError, Error),
        alsatian_core_1.TestCase(URIError, EvalError),
        alsatian_core_1.TestCase(URIError, ReferenceError),
        alsatian_core_1.TestCase(URIError, TypeError),
        alsatian_core_1.TestCase(URIError, SyntaxError), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Function, Function]), 
        __metadata('design:returntype', void 0)
    ], ErrorMatchErrorTests.prototype, "actualErrorIsCorrectTypeButShouldntBeGivesCorrectMessage", null);
    return ErrorMatchErrorTests;
}());
exports.ErrorMatchErrorTests = ErrorMatchErrorTests;
//# sourceMappingURL=error-match-error.spec.js.map